//
//  ExMenu.m
//  cocos2dAdventCalendarDay9
//
//  Created by 岩井 雅幸 on 11/12/08.
//  Copyright 2011年 myb design. All rights reserved.
//

#import "ExMenu.h"


@implementation ExMenu

- (id)init
{
	if((self = [super init]))
	{
		longPressTimer = nil;
		longPressState = kExMenuLongPressStateNone;
	}
	return self;
}


- (void)dealloc
{
	if(longPressTimer != nil)
	{
		[longPressTimer invalidate];
	}
	
	[super dealloc];
}


- (BOOL)ccTouchBegan:(UITouch *)touch withEvent:(UIEvent *)event
{
	BOOL result = [super ccTouchBegan:touch withEvent:event];
	if(result)
	{
		if(longPressTimer != nil)
		{
			[longPressTimer invalidate];
		}
		
		longPressTimer = [NSTimer scheduledTimerWithTimeInterval:kExMenuLongPressInterval 
														  target:self selector:@selector(didFireLongPressTimer:) 
														userInfo:nil repeats:NO];
		longPressState = kExMenuLongPressStateBegan;
	}
	else
	{
		longPressState = kExMenuLongPressStateNone;
	}
	
	return result;
}

-(void) ccTouchMoved:(UITouch *)touch withEvent:(UIEvent *)event
{
	if(longPressState == kExMenuLongPressStateFired)
	{
		// didFireLongPressTimerでccTouchEndedを呼ぶのでここでは呼ばない
	}
	else
	{
		[super ccTouchMoved:touch withEvent:event];
	}
}


- (void)ccTouchEnded:(UITouch *)touch withEvent:(UIEvent *)event
{
	if(longPressTimer != nil)
	{
		[longPressTimer invalidate];
		longPressTimer = nil;
	}
	
	if(longPressState == kExMenuLongPressStateFired)
	{
		// didFireLongPressTimerでccTouchEndedを呼ぶのでここでは呼ばない
	}
	else
	{
		longPressState = kExMenuLongPressStateNone;
		[super ccTouchEnded:touch withEvent:event];
	}
}


- (void)ccTouchCancelled:(UITouch *)touch withEvent:(UIEvent *)event
{
	if(longPressTimer != nil)
	{
		[longPressTimer invalidate];
		longPressTimer = nil;
	}
	
	longPressState = kExMenuLongPressStateNone;
	[super ccTouchCancelled:touch withEvent:event];
}


- (void)didFireLongPressTimer:(NSTimer *)timer
{
	longPressTimer = nil;
	
	if(longPressState == kExMenuLongPressStateBegan)
	{
		longPressState = kExMenuLongPressStateFired;
		[super ccTouchEnded:nil withEvent:nil];
	}
	else
	{
		longPressState = kExMenuLongPressStateNone;
	}
}


- (BOOL)isLongPress
{
	return (longPressState == kExMenuLongPressStateFired);
}

@end
