//
//  ExMenuItemSprite.m
//  cocos2dAdventCalendarDay9
//
//  Created by 岩井 雅幸 on 11/12/08.
//  Copyright 2011年 myb design. All rights reserved.
//

#import "ExMenuItemSprite.h"


@implementation ExMenuItemSprite

- (void)adaptChildrenAppearanceTo:(CCNode <CCRGBAProtocol> *)target
{
	for(CCNode *node in children_)
	{
		if([node isEqual:normalImage_] || [node isEqual:selectedImage_] || [node isEqual:disabledImage_])
			continue;
		
		if(![node conformsToProtocol:@protocol(CCRGBAProtocol)])
			continue;
		
		[(CCNode <CCRGBAProtocol> *)node setOpacity:[target opacity]];
	}
}


- (void)selected
{
	[super selected];
	[self adaptChildrenAppearanceTo:selectedImage_];
}


- (void)unselected
{
	[super unselected];
	[self adaptChildrenAppearanceTo:normalImage_];
}


- (void)setIsEnabled:(BOOL)enabled
{
	[super setIsEnabled:enabled];
	
	if(enabled)
	{
		if(self.isSelected)
		{
			[self adaptChildrenAppearanceTo:selectedImage_];
		}
		else
		{
			[self adaptChildrenAppearanceTo:normalImage_];
		}
	}
	else
	{
		if(self.disabledImage)
		{
			[self adaptChildrenAppearanceTo:disabledImage_];
		}
		else
		{
			[self adaptChildrenAppearanceTo:normalImage_];
		}
	}
}

@end
