//
//  HelloWorldLayer.m
//  cocos2dAdventCalendarDay9
//
//  Created by 岩井 雅幸 on 11/12/08.
//  Copyright myb design 2011年. All rights reserved.
//


// Import the interfaces
#import "HelloWorldLayer.h"
#import "ExMenu.h"
#import "ExMenuItemSprite.h"


// HelloWorldLayer implementation
@implementation HelloWorldLayer

+(CCScene *) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	HelloWorldLayer *layer = [HelloWorldLayer node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init])) {
		
		CCLayerColor *layer = [CCLayerColor layerWithColor:ccc4(0x00, 0x99, 0xcc, 0xff)];
		[self addChild:layer];
		
		// メインのボタン
		NSMutableArray *mainMenuItems = [NSMutableArray arrayWithCapacity:2];
		
		{
			CCSprite *normalSprite = [CCSprite spriteWithFile:@"button1.png"];
			CCSprite *selectedSprite = [CCSprite spriteWithFile:@"button1.png"];
			selectedSprite.opacity = 0x7f;
			CCSprite *disabledSprite = [CCSprite spriteWithFile:@"button1.png"];
			disabledSprite.opacity = 0x7f;
			
			ExMenuItemSprite *menuItem = [ExMenuItemSprite itemFromNormalSprite:normalSprite 
																 selectedSprite:selectedSprite 
																 disabledSprite:disabledSprite target:nil selector:nil];
			
			CCLabelTTF *label = [CCLabelTTF labelWithString:@"Push     me!!!" fontName:@"Arial" fontSize:30.0f];
			label.color = ccc3(0x22, 0x22, 0x22);
			label.position = ccp(menuItem.contentSize.width / 2.0f, menuItem.contentSize.height / 2.0f);
			[menuItem addChild:label];
			[mainMenuItems addObject:menuItem];
		}
		
		{
			CCSprite *normalSprite = [CCSprite spriteWithFile:@"button2.png"];
			CCSprite *selectedSprite = [CCSprite spriteWithFile:@"button2.png"];
			selectedSprite.opacity = 0x7f;
			CCSprite *disabledSprite = [CCSprite spriteWithFile:@"button2.png"];
			disabledSprite.opacity = 0x7f;
			
			ExMenuItemSprite *menuItem = [ExMenuItemSprite itemFromNormalSprite:normalSprite 
																 selectedSprite:selectedSprite 
																 disabledSprite:disabledSprite target:nil selector:nil];
			
			CCLabelTTF *label = [CCLabelTTF labelWithString:@"Hold     me!!!" fontName:@"Arial" fontSize:30.0f];
			label.color = ccc3(0xee, 0xee, 0xee);
			label.position = ccp(menuItem.contentSize.width / 2.0f, menuItem.contentSize.height / 2.0f);
			[menuItem addChild:label];
			[mainMenuItems addObject:menuItem];
		}
		
		CCMenuItemToggle *mainToggleItem = [CCMenuItemToggle itemWithTarget:self selector:@selector(didPressMainButton:) 
																	  items:[mainMenuItems objectAtIndex:0], [mainMenuItems objectAtIndex:1], nil];
		
		mainMenu = [ExMenu menuWithItems:mainToggleItem, nil];
		[self addChild:mainMenu];
		mainMenuSelectedIndex = 0;
		
		// 有効・無効切り替えボタン
		NSMutableArray *enableMenuItems = [NSMutableArray arrayWithCapacity:2];
		
		{
			CCSprite *normalSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			CCSprite *selectedSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			selectedSprite.opacity = 0x7f;
			CCSprite *disabledSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			disabledSprite.opacity = 0x7f;
			
			ExMenuItemSprite *menuItem = [ExMenuItemSprite itemFromNormalSprite:normalSprite 
																 selectedSprite:selectedSprite 
																 disabledSprite:disabledSprite target:nil selector:nil];
			
			CCLabelTTF *label = [CCLabelTTF labelWithString:@"DISABLE" fontName:@"Arial" fontSize:12.0f];
			label.position = ccp(menuItem.contentSize.width / 2.0f, menuItem.contentSize.height / 2.0f);
			[menuItem addChild:label];
			[enableMenuItems addObject:menuItem];
		}
		
		{
			CCSprite *normalSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			CCSprite *selectedSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			selectedSprite.opacity = 0x7f;
			CCSprite *disabledSprite = [CCSprite spriteWithFile:@"enable_button.png"];
			disabledSprite.opacity = 0x7f;
			
			ExMenuItemSprite *menuItem = [ExMenuItemSprite itemFromNormalSprite:normalSprite 
																 selectedSprite:selectedSprite 
																 disabledSprite:disabledSprite target:nil selector:nil];
			
			CCLabelTTF *label = [CCLabelTTF labelWithString:@"ENABLE" fontName:@"Arial" fontSize:12.0f];
			label.position = ccp(menuItem.contentSize.width / 2.0f, menuItem.contentSize.height / 2.0f);
			[menuItem addChild:label];
			[enableMenuItems addObject:menuItem];
		}

		CCMenuItemToggle *enableToggleItem = [CCMenuItemToggle itemWithTarget:self selector:@selector(didPressEnableButton:) 
																		items:[enableMenuItems objectAtIndex:0], [enableMenuItems objectAtIndex:1], nil];
		CCMenu *enableMenu = [CCMenu menuWithItems:enableToggleItem, nil];
		enableMenu.position = ccp(428.0f, 30.0f);
		[self addChild:enableMenu];
		
	}
	return self;
}

// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}


- (void)didPressMainButton:(CCMenuItem *)sender
{
	ExMenu *menu = (ExMenu *)sender.parent;
	if([menu isLongPress])
	{
		mainMenuSelectedIndex = ((CCMenuItemToggle *)sender).selectedIndex;
	}
	else
	{
		// 長押しでなかったらselectedIndexを強制的に前の値に戻す
		((CCMenuItemToggle *)sender).selectedIndex = mainMenuSelectedIndex;
	}
}


- (void)didPressEnableButton:(CCMenuItem *)sender
{
	CCMenuItem *menuItem = (CCMenuItem *)[mainMenu.children objectAtIndex:0];
	[menuItem setIsEnabled:((CCMenuItemToggle *)sender).selectedIndex == 0];
}


@end
